## yubico-piv-tool 2.5.2

=== CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required (VERSION 3.5)
# policy CMP0025 is to get AppleClang identifier rather than Clang for both
# this matters since the apple compiler accepts different flags.
cmake_policy(SET CMP0025 NEW)
cmake_policy(SET CMP0042 NEW)
cmake_policy(SET CMP0054 NEW)

include(CheckFunctionExists)

set (CMAKE_C_STANDARD 11)

project (yubico-piv-tool)

set (yubico_piv_tool_VERSION_MAJOR 2)
set (yubico_piv_tool_VERSION_MINOR 5)
set (yubico_piv_tool_VERSION_PATCH 2)
set (VERSION "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")
set (SO_VERSION 2)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(${CMAKE_SOURCE_DIR}/cmake/options.cmake)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

include(CheckCCompilerFlag)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

add_definitions(-DOPENSSL_API_COMPAT=0x10000000L)

if(WIN32)
    add_definitions(-DWIN32_LEAN_AND_MEAN)
    set(_WIN32 ${WIN32})
endif()

if(MSVC)
    if((NOT GETOPT_LIB_DIR) OR (NOT GETOPT_INCLUDE_DIR))
        message(FATAL_ERROR "please provide definitions for "
                "GETOPT_LIB_DIR and GETOPT_INCLUDE_DIR when building "
                "under msvc")
    endif()
    if(SUPRESS_MSVC_WARNINGS)
        set(MSVC_DISABLED_WARNINGS_LIST
            "C4706" # assignment within conditional expression;
            "C4996" # The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name
            "C4244" # Conversion from 'int' to 'unsigned char', possible loss of data
            "C4152" # Nonstandard extension, function/data pointer conversion in expression (openssl/applink.c)
            "C4068" # Unknown pragma
            "C4100" # 'param': unreferenced formal parameter (unsupported pkcs11 functions)
            "C4267" # Conversion from 'size_t' to 'CK_ULONG'
            "C4312" # Conversion from 'unsigned int' to 'void *' of greater size (ykcs11/utils.c:noop_create_mutex)
            "C5105" # Macro expansion producing 'defined' has undefined behavior
            )
        # The construction in the following 3 lines was taken from LibreSSL's
        # CMakeLists.txt.
        string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR ${MSVC_DISABLED_WARNINGS_LIST})
        string(REGEX REPLACE "[/-]W[1234][ ]?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 ${MSVC_DISABLED_WARNINGS_STR}")
    endif(SUPRESS_MSVC_WARNINGS)

    set(BUILD_SHARED_LIBS ON)
    set(GENERATE_MAN_PAGES OFF)
    set(LIBCRYPTO_LIBRARIES ${LIBCRYPTO_LIBRARIES} bcrypt)
else()
    find_package (PkgConfig REQUIRED)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-missing-braces")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat -Wformat-security")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -Wpointer-arith")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wbad-function-cast")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-pointer-sign")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g2")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
endif()

# Use -Wshorten-64-to-32 if available.
check_c_compiler_flag("-Wshorten-64-to-32" HAVE_SHORTEN_64_TO_32)
if(HAVE_SHORTEN_64_TO_32)
#    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshorten-64-to-32")
endif()

# Avoid https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66425
if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result")
endif()

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()
include_directories(${LIBCRYPTO_INCLUDE_DIRS})

enable_testing()
find_package(codecov)

# explicit_bzero
check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
if(HAVE_EXPLICIT_BZERO)
	add_definitions(-DHAVE_EXPLICIT_BZERO)
endif()

add_subdirectory (lib)
if(NOT BUILD_ONLY_LIB)
    add_subdirectory(ykcs11)
    add_subdirectory(tool)
endif()

coverage_evaluate()

message("Build summary:")
message("")
message("        Project name:     ${CMAKE_PROJECT_NAME}")
message("        Version:          ${VERSION}")
message("        Host type:        ${CMAKE_SYSTEM_NAME}")
message("        Install prefix:   ${CMAKE_PREFIX_PATH}")
message("        Compiler:         ${CMAKE_C_COMPILER}")
message("        Compiler ID:      ${CMAKE_C_COMPILER_ID}")
message("        CFLAGS:           ${CMAKE_C_FLAGS}")
message("        CFLAGS_DEBUG:     ${CMAKE_C_FLAGS_DEBUG}")
message("        CPPFLAGS:         ${CMAKE_CXX_FLAGS}")
message("        Warnings:         ${WARN_FLAGS}")
message("        Build type:       ${CMAKE_BUILD_TYPE}")
message("        Backend:          ${BACKEND}")
message("        PCSC")
message("                CFLAGS:   ${PCSC_CFLAGS}")
message("                LIBS:     ${PCSC_LIBRARIES}")
message("        Winscard")
message("                LIBS:     ${PCSC_WIN_LIBS}")
message("        Mac PCSC")
message("                LIBS:     ${PCSC_MACOSX_LIBS}")
message("        Custom PCSC")
message("                LIBS:     ${PCSC_CUSTOM_LIBS}")
message("")
message("        Install prefix:    ${CMAKE_INSTALL_PREFIX}")
message("        Install targets")
message("                Libraries  ${YKPIV_INSTALL_LIB_DIR}")
message("                Includes   ${YKPIV_INSTALL_INC_DIR}")
message("                Binaries   ${YKPIV_INSTALL_BIN_DIR}")
message("                Manuals    ${YKPIV_INSTALL_MAN_DIR}")
message("                Pkg-config ${YKPIV_INSTALL_PKGCONFIG_DIR}")
message("")
message("        YKCS11 debug:     ${ENABLE_YKCS11_DBG}")
if(ENABLE_HARDWARE_TESTS)
    message("        Hardware tests:   Enabled. *** WARNING: RUNNING THE TESTS WILL ERASE ALL DATA ON CONNECTED YUBIKEYS *** ")
else(ENABLE_HARDWARE_TESTS)
    message("        Hardware tests:   Disabled")
endif(ENABLE_HARDWARE_TESTS)

=== lib/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/CMakeList.txt")

include(${CMAKE_SOURCE_DIR}/cmake/pcscd.cmake)
find_pcscd()

set(YKPIV_VERSION_STRING "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

set(SOURCE
        ykpiv.c
        util.c
        version.c
        error.c
        internal.c
        ../common/openssl-compat.c
        ../common/util.c)

include_directories(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_SOURCE_DIR}/common
)

if (ENABLE_CERT_COMPRESS)
    add_definitions(-DUSE_CERT_COMPRESS="1")

    find_library(ZLIB zlib PATHS ${ZLIB_LIB_DIR})
    include_directories(${ZLIB_INCL_DIR})

    find_package(ZLIB REQUIRED)

    set(ZLIB_LIBS "ZLIB::ZLIB")
endif()

# static library
if(BUILD_STATIC_LIB)
    add_library(ykpiv STATIC ${SOURCE})
    target_link_libraries(ykpiv ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS})
    set_target_properties (ykpiv PROPERTIES COMPILE_FLAGS "-DSTATIC ")
    if(WIN32)
        set_target_properties(ykpiv PROPERTIES OUTPUT_NAME ykpiv_static)
    endif()
    add_coverage(ykpiv)
endif(BUILD_STATIC_LIB)

# dynamic library
add_library(ykpiv_shared SHARED ${SOURCE})
target_link_libraries(ykpiv_shared ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS})
set_target_properties(ykpiv_shared PROPERTIES SOVERSION ${SO_VERSION} VERSION ${VERSION})
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set_target_properties(ykpiv_shared PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
endif()
if(WIN32)
    set_target_properties(ykpiv_shared PROPERTIES OUTPUT_NAME libykpiv)
else(WIN32)
    set_target_properties(ykpiv_shared PROPERTIES OUTPUT_NAME ykpiv)
endif(WIN32)
add_coverage(ykpiv_shared)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykpiv.pc.in ${CMAKE_CURRENT_SOURCE_DIR}/ykpiv.pc @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykpiv-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/ykpiv-config.h @ONLY)

install(
        TARGETS ykpiv_shared
        ARCHIVE DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        LIBRARY DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        RUNTIME DESTINATION ${YKPIV_INSTALL_BIN_DIR})
if(BUILD_STATIC_LIB)
    install(
        TARGETS ykpiv
        ARCHIVE DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        LIBRARY DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        RUNTIME DESTINATION ${YKPIV_INSTALL_BIN_DIR})
endif(BUILD_STATIC_LIB)

install(FILES ykpiv.h DESTINATION ${YKPIV_INSTALL_INC_DIR}/ykpiv)
install(FILES ykpiv-config.h DESTINATION ${YKPIV_INSTALL_INC_DIR}/ykpiv)

install(FILES ykpiv.pc DESTINATION ${YKPIV_INSTALL_PKGCONFIG_DIR})

add_subdirectory(tests)

=== debian/changelog ===
yubico-piv-tool (2.5.2-1) unstable; urgency=medium

  * New upstream version 2.5.2
  * Fix lintian override

 -- Patrick Winnertz <winnie@debian.org>  Thu, 09 May 2024 20:41:06 +0200

yubico-piv-tool (2.5.1-1) unstable; urgency=medium

  * Update siging-keys according to the keys listed on the yubico website.
  * New upstream version 2.5.1 (Closes: #1023561)
  * Remove all patches - they are now incorporated upstream.
  * Remove upstream from uploaders as stated in a private mail from
    Alessio Di Mauro
  * Take over Uploaders from Nicoo, according to Salvage Process.
  * Update copyright
  * Bump standards version to 4.7.0 - no changes needed.

 -- Patrick Winnertz <winnie@debian.org>  Sun, 05 May 2024 13:26:31 +0200

## yubico-piv-tool 2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,8 +39,8 @@
 project (yubico-piv-tool)
 
 set (yubico_piv_tool_VERSION_MAJOR 2)
-set (yubico_piv_tool_VERSION_MINOR 5)
-set (yubico_piv_tool_VERSION_PATCH 2)
+set (yubico_piv_tool_VERSION_MINOR 7)
+set (yubico_piv_tool_VERSION_PATCH 1)
 set (VERSION "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")
 set (SO_VERSION 2)

=== tool/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("tool/CMakeList.txt")

set (SOURCE
        yubico-piv-tool.c
        ../common/openssl-compat.c
        ../common/util.c)

if(WIN32)
    add_definitions (-DPACKAGE="yubico-piv-tool")
    add_definitions (-DVERSION="${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")

    set(SOURCE ${SOURCE} cmdline.c)

    find_library(GETOPT getopt PATHS ${GETOPT_LIB_DIR})
    include_directories(${GETOPT_INCLUDE_DIR})

    find_library(ZLIB zlib PATHS ${ZLIB_LIB_DIR})
    include_directories(${ZLIB_INCL_DIR})

    set(LINK_LIBS_WIN ${GETOPT} ${ZLIB})
else(WIN32)
    include(${CMAKE_SOURCE_DIR}/cmake/gengetopt.cmake)
    find_gengetopt()
    add_gengetopt_files(cmdline)
    set(SOURCE ${SOURCE} ${GGO_C})
endif(WIN32)

include_directories (
        ${CMAKE_SOURCE_DIR}/lib
        ${CMAKE_CURRENT_SOURCE_DIR}
)

find_package(ZLIB REQUIRED)

add_executable (yubico-piv-tool ${SOURCE})
target_link_libraries(yubico-piv-tool ${LIBCRYPTO_LDFLAGS} ${LINK_LIBS_WIN} ZLIB::ZLIB ykpiv_shared)
add_coverage(yubico-piv-tool)

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set_target_properties(yubico-piv-tool PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
endif()

install(
        TARGETS yubico-piv-tool
        ARCHIVE DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        RUNTIME DESTINATION "${YKPIV_INSTALL_BIN_DIR}")

if (GENERATE_MAN_PAGES)
    include (${CMAKE_SOURCE_DIR}/cmake/help2man.cmake)
    add_help2man_manpage (yubico-piv-tool.1 yubico-piv-tool "Tool for managing Personal Identity Verification credentials on Yubikeys")

    add_custom_target (yubico-piv-tool-man ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1" DESTINATION "${YKPIV_INSTALL_MAN_DIR}/man1")
endif(GENERATE_MAN_PAGES)

# If somehow a manpage was generated before configure started, install that too
find_file(MAN_PAGE yubico-piv-tool.1 PATHS ${CMAKE_CURRENT_SOURCE_DIR})
if(MAN_PAGE)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1" DESTINATION "${YKPIV_INSTALL_MAN_DIR}/man1")
endif(MAN_PAGE)

add_subdirectory(tests)

=== ykcs11/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("ykcs11/tests/CMakeList.txt")

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)
    if(ENABLE_HARDWARE_TESTS)
        if(NOT WIN32)
            add_test(
                NAME reset_tests
                COMMAND ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/reset.sh
            )
            set_property(TEST reset_tests APPEND PROPERTY ENVIRONMENT "EXEEXT=${CMAKE_EXECUTABLE_SUFFIX}")
            set_property(TEST reset_tests APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")
        else(NOT WIN32)
            message("Running on Windows. Skipping basic tests...")
        endif(NOT WIN32)
    endif(ENABLE_HARDWARE_TESTS)

    set(SOURCE_YKCS11_TESTS
            ykcs11_tests.c
            ykcs11_tests_util.c
    )
    add_executable(test_ykcs11 ${SOURCE_YKCS11_TESTS})
    target_link_libraries(test_ykcs11 ykcs11_shared ${LIBCRYPTO_LDFLAGS})
    add_test(
        NAME test_ykcs11
        COMMAND test_ykcs11
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/ykcs11/tests/
    )
    set_property(TEST test_ykcs11 APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")

    set(SOURCE_YKCS11_INTERFACES_TESTS ykcs11_interfaces_tests.c)
    add_executable(test_ykcs11_interfaces ${SOURCE_YKCS11_INTERFACES_TESTS})
    target_link_libraries(test_ykcs11_interfaces ykcs11_shared ${LIBCRYPTO_LDFLAGS})
    add_test(
        NAME test_ykcs11_interfaces
        COMMAND test_ykcs11_interfaces
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/ykcs11/tests/
    )
    set_property(TEST test_ykcs11_interfaces APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")

    set(SOURCE_YKCS11_EDX_TESTS
            ykcs11_edx_test.c
            ykcs11_tests_util.c
            )
    add_executable(test_ykcs11_edx ${SOURCE_YKCS11_EDX_TESTS})
    target_link_libraries(test_ykcs11_edx ykcs11_shared ${LIBCRYPTO_LDFLAGS})
    add_test(
            NAME test_ykcs11_edx
            COMMAND test_ykcs11_edx
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/ykcs11/tests/
    )
    set_property(TEST test_ykcs11_edx APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")

endif(NOT DEFINED SKIP_TESTS)

=== debian/changelog ===
yubico-piv-tool (2.7.1-1) unstable; urgency=medium

  * New upstream version 2.7.1
  * Update Copyright add 2025 to debian/*
  * Update Copyright
  * Add more symbols to the symbols file

 -- Patrick Winnertz <winnie@debian.org>  Fri, 24 Jan 2025 14:04:20 +0100

=== debian/control ===
Source: yubico-piv-tool
Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders: Patrick Winnertz <winnie@debian.org>, nicoo <nicoo@debian.org>
Section: utils
Priority: optional
Build-Depends:
	debhelper-compat (= 13),
  cmake,
	pkgconf,
	check,
	gengetopt,
	help2man,
	libpcsclite-dev,
	libssl-dev,
        zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://developers.yubico.com/yubico-piv-tool/
Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git
Rules-Requires-Root: no

Package: libykpiv2
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pcscd
Description: Library for communication with the YubiKey PIV smartcard
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the run-time shared library.  You normally don't
 need to install it manually.

Package: libykpiv-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv2 (= ${binary:Version})
Description: Development files for the YubiKey PIV Library
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the development files for the library.

Package: yubico-piv-tool
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Command line tool for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the command-line tool.

Package: ykcs11
Architecture: any
Section: libs
Multi-Arch: no
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv2 (= ${binary:Version})
Description: PKCS#11 module for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the PKCS#11 module.

## yubico-piv-tool 2.7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 
 set (yubico_piv_tool_VERSION_MAJOR 2)
 set (yubico_piv_tool_VERSION_MINOR 7)
-set (yubico_piv_tool_VERSION_PATCH 1)
+set (yubico_piv_tool_VERSION_PATCH 2)
 set (VERSION "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")
 set (SO_VERSION 2)

=== common/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("common/CMakeList.txt")

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()

set (
        SOURCE
        util.c
        openssl-compat.c
)

include_directories(${CMAKE_SOURCE_DIR}/lib)

set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

add_library (ykpivcommon STATIC ${SOURCE})
set_target_properties (ykpivcommon PROPERTIES COMPILE_FLAGS "-DSTATIC " )
target_link_libraries (ykpivcommon ykpiv_static ${LIBCRYPTO_LDFLAGS})

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -40,6 +40,10 @@
         version.c
         error.c
         internal.c
+        ecdh.c
+        scp11_util.c
+        ../aes_cmac/aes.c
+        ../aes_cmac/aes_cmac.c
         ../common/openssl-compat.c
         ../common/util.c)
 
@@ -59,10 +63,14 @@
     set(ZLIB_LIBS "ZLIB::ZLIB")
 endif()
 
+if(WIN32)
+    set(ADDITIONAL_LIBRARY ws2_32)
+endif ()
+
 # static library
 if(BUILD_STATIC_LIB)
     add_library(ykpiv STATIC ${SOURCE})
-    target_link_libraries(ykpiv ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS})
+    target_link_libraries(ykpiv ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS} ${ADDITIONAL_LIBRARY})
     set_target_properties (ykpiv PROPERTIES COMPILE_FLAGS "-DSTATIC ")
     if(WIN32)
         set_target_properties(ykpiv PROPERTIES OUTPUT_NAME ykpiv_static)
@@ -72,7 +80,7 @@
 
 # dynamic library
 add_library(ykpiv_shared SHARED ${SOURCE})
-target_link_libraries(ykpiv_shared ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS})
+target_link_libraries(ykpiv_shared ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${ZLIB_LIBS} ${ADDITIONAL_LIBRARY})
 set_target_properties(ykpiv_shared PROPERTIES SOVERSION ${SO_VERSION} VERSION ${VERSION})
 if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
     set_target_properties(ykpiv_shared PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")

=== tool/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,9 @@
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 message("tool/CMakeList.txt")
+
+include(${CMAKE_SOURCE_DIR}/cmake/pcscd.cmake)
+find_pcscd()
 
 set (SOURCE
         yubico-piv-tool.c

=== lib/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/tests/CMakeList.txt")

if(CMAKE_C_COMPILER_ID MATCHES Clang)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE")
elseif(NOT MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE -pie")
endif()

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)
    set(SOURCE_BASIC basic.c)
    set(SOURCE_API api.c ../../aes_cmac/aes.c)
    set(SOURCE_PARSE_KEY parse_key.c)
    set(SOURCE_AES aes.c)

    add_executable (test_basic ${SOURCE_BASIC})
    add_executable(test_api ${SOURCE_API})
    add_executable(test_parse_key ${SOURCE_PARSE_KEY})
    add_executable(test_aes ${SOURCE_AES})

    target_link_libraries(test_basic ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_api ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_parse_key ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_aes ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})

    if(${ENABLE_HARDWARE_TESTS})
        set(HW_TESTS 1)
    endif(${ENABLE_HARDWARE_TESTS})

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/test-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/test-config.h @ONLY)

    add_test(
        NAME basic
        COMMAND test_basic
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )

    add_test(
        NAME api
        COMMAND test_api
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )
    set_property(TEST api APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")

    add_test(
        NAME parse_key
        COMMAND test_parse_key
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )

    add_test(
        NAME aes
        COMMAND test_aes
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )
endif(NOT DEFINED SKIP_TESTS)

=== tool/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/tool/CMakeList.txt")

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)

    if(${ENABLE_HARDWARE_TESTS})
        set(HW_TESTS 1)
    endif(${ENABLE_HARDWARE_TESTS})

    set(SOURCE_PARSE_NAME parse_name.c)
    set(SOURCE_TEST_INOUT test_inout.c)

    include_directories(${LIBCRYPTO_INCLUDE_DIRS})

    add_executable(test_parse_name ${SOURCE_PARSE_NAME})
    add_executable (test_inout ${SOURCE_TEST_INOUT})

    target_link_libraries(test_parse_name ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_inout ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})

    add_test(
        NAME test_parse_name
        COMMAND test_parse_name
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tool/tests/
    )

    add_test(
        NAME test_inout
        COMMAND test_inout
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/tool/tests/
    )

    if(NOT WIN32 AND ENABLE_HARDWARE_TESTS)
        configure_file (
            ${CMAKE_CURRENT_SOURCE_DIR}/cert.pem
            ${CMAKE_CURRENT_BINARY_DIR}/cert.pem
            COPYONLY)

        configure_file (
            ${CMAKE_CURRENT_SOURCE_DIR}/private.pem
            ${CMAKE_CURRENT_BINARY_DIR}/private.pem
            COPYONLY)

        configure_file (
            ${CMAKE_CURRENT_SOURCE_DIR}/public.pem
            ${CMAKE_CURRENT_BINARY_DIR}/public.pem
            COPYONLY)

        add_test(
            NAME basic_tests
            COMMAND ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/basic.sh
        )
        set_property(TEST basic_tests APPEND PROPERTY ENVIRONMENT "VERSION=${VERSION}")
        set_property(TEST basic_tests APPEND PROPERTY ENVIRONMENT "EXEEXT=${CMAKE_EXECUTABLE_SUFFIX}")
        set_property(TEST basic_tests APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")
    else(NOT WIN32 AND ENABLE_HARDWARE_TESTS)
        message("Running on Windows. Skipping basic tests...")
    endif(NOT WIN32 AND ENABLE_HARDWARE_TESTS)
endif(NOT DEFINED SKIP_TESTS)

=== debian/changelog ===
yubico-piv-tool (2.7.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 2.7.2
  * Standards-Version: 4.7.2.
  * Improve d/copyright wrt openssl-compat and myself.
  * Add d/salsa-ci.yml.
  * Run wrap-and-sort -satbk.
  * Drop irrelevant d/README.source.
  * Change Maintainer: from pkg-auth to pkg-security.
  * Add upstream/metadata.
  * Drop old MISSING from symbols files.
  * Fix wrap-and-sort.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 29 Aug 2025 18:56:18 +0200

=== debian/control ===
Source: yubico-piv-tool
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Patrick Winnertz <winnie@debian.org>,
 nicoo <nicoo@debian.org>,
Section: utils
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 check,
 cmake,
 gengetopt,
 help2man,
 libpcsclite-dev,
 libssl-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.2
Homepage: https://developers.yubico.com/yubico-piv-tool/
Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git
Rules-Requires-Root: no

Package: libykpiv2
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pcscd,
Description: Library for communication with the YubiKey PIV smartcard
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the run-time shared library.  You normally don't
 need to install it manually.

Package: libykpiv-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libykpiv2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Development files for the YubiKey PIV Library
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the development files for the library.

Package: ykcs11
Architecture: any
Section: libs
Multi-Arch: no
Depends:
 libykpiv2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: PKCS#11 module for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the PKCS#11 module.

Package: yubico-piv-tool
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Command line tool for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the command-line tool.
